(function() {
    tinymce.PluginManager.add('custom_tmce_pppcp_button', function( editor, url ) {
		var sh_tag 		= 'paypalpromo',
			sh_tag2		= 'pppviewcart',
			sh_id		= 'pppbutton',
			sh_id2		= 'pppcart',
			wp_obj		= paypalPPButtons,
			touchStart 	= false,
			tapped 		= false;

		function getAttr(s, n) {
			n = new RegExp(n + '=\"([^\"]+)\"', 'g').exec(s);
			return n ?  window.decodeURIComponent(n[1]) : '';
		};

		function toTitleCase( str ){
    		return str.replace(/\w\S*/g, function(txt){return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();});
		}

		function getMatches( string, regex, index ) {
			index || (index = 1); // default to the first capturing group
			var matches = [],
				tmatch;
			while (tmatch = regex.exec(string)) {
				matches.push(tmatch[index]);
			}
			return matches;
		}

		function html( cls, data ,con) {
			var placeholder = url + '/img/paypal-placeholder.png';
			if(cls == sh_tag2 + '_shortcode'){
				placeholder = url + '/img/viewcart-placeholder.gif';
				return '<img style="display:block;max-width:100%;width:107px;height:auto;cursor:pointer;margin:5px;padding:2px;outline: none;border: 1px dashed rgba(0, 0, 0, 0.13);" src="' + placeholder + '" class="mceItem ' + cls + '" ' + 'data-sh-attr="" data-sh-id="' + sh_id2 + '" data-sh-content="' + con + '" data-mce-resize="false" data-mce-placeholder="1" />';
			}else if( cls == sh_tag + '_shortcode'){
				var balign = getAttr(data,'align');
				balignT = balign == '' ? '' : ' '+ balign +' ';
				balignM = balign == 'aligncenter' || balign == '' ? 'margin:0 auto;' : '';
				data 	= window.encodeURIComponent( data );
				var temp = '<img style="max-width:100%;width:287px;height:auto;cursor:pointer;' + balignM + 'outline: none;border: 1px dashed rgba(0, 0, 0, 0.13);" src="' + placeholder + '" class="mceItem ' + cls + balignT + '" ' + 'data-sh-attr="' + data + '" data-sh-id="' + sh_id + '" data-sh-content="' + con + '" data-mce-resize="false" data-mce-placeholder="1" />';
				return  temp;
			}
			return con;
		}

		function replaceShortcodes( content ) {
			var scOpened = new RegExp("\\[" + sh_tag + "([^\\]]*)\\]","g"),
				scCart 	 = new RegExp("\\[" + sh_tag2 + "([^\\]]*)\\]","g"),
			content = content.replace( scOpened, function( all,attr,con) {
				return html(  sh_tag + '_shortcode', attr , '');
			});
			content = content.replace( scCart, function( all,attr,con) {
				return html( sh_tag2 + '_shortcode', attr , '');
			});			
			return content;
		}

		function restoreShortcodes( content ) {
			return content.replace( /(?:<p(?: [^>]+)?>)*(<img [^>]+>)(?:<\/p>)*/g, function( match, image ) {
				var data 		= getAttr( image, 'data-sh-attr' ),
					tid			= getAttr( image, 'data-sh-id' );
				if ( data != '' && tid == sh_id) // button shortcode
					return '[' + sh_tag + data + ']';
				if( data == '' && tid == sh_id2 ) // cart shortcode
					return '[' + sh_tag2 + ']';
				return match;
			});
		}
		
		function openEditorPayPalPromo(e) {
			//console.log('editor clicked');
			//console.log(e.target.className);
			var cls  = e.target.className.indexOf( sh_tag + '_shortcode');
			var cls2  = e.target.className.indexOf( sh_tag2 + '_shortcode');
			if ( e.target.nodeName == 'IMG' && cls > -1 ) {
				var popupTitle = e.target.attributes['data-sh-attr'].value;
				console.log(popupTitle);
				popupTitle 	= window.decodeURIComponent(popupTitle);
				var content = e.target.attributes['data-sh-content'].value;
				editor.execCommand(sh_tag + '_shortcode_popup','',{
					id 			: getAttr(popupTitle,'id') ,
					align   	: getAttr(popupTitle,'align'),
					hide_title  : getAttr(popupTitle,'hide_title'),
					content		: content
				});
			}else if( e.target.nodeName == 'IMG' && cls2 > -1 ){

			}
		}

		editor.addCommand( sh_tag + '_shortcode_popup', function(ui, v) {
			if (!String.prototype.trim) {String.prototype.trim = function() {return this.replace(/^\s+|\s+$/g,'');}}
			
			var shortcode_str = '[' + sh_tag ,
				align 		= v.align ? v.align : '',
				id 			= v.id ? v.id : 0,
				hide_title	= v.hide_title ? v.hide_title : 0;
				var opts = [];
				if( wp_obj.buttons.length > 0){
					opts.push({text: '-- Select One --', value: '0'});
					for (i = 0; i < wp_obj.buttons.length ; i++) { 
						opts.push({text: wp_obj.buttons[i].pid + '-' + wp_obj.buttons[i].item_name , value: wp_obj.buttons[i].pid});
					}
				}else{
					opts.push({text: 'Please create a button.', value: '-1'});
				}
			editor.windowManager.open( {
				title: 'Insert PayPal Button',
				minWidth: 200,
				body: [{
					type: 'listbox', 
					name: 'id', 
					label: 'PayPal Button', 
					values: opts,
					value: id,
					minWidth: 150,
				},
				{
					type: 'checkbox', 
					name: 'hide_title', 
					label: 'Hide Button Title?', 
					value: 1,
					checked: (hide_title == 1 ? true : false),
					style: ''
				},	
				{
					type: 'listbox', 
					name: 'align', 
					label: 'Align Promo Box', 
					values: [
						{ text: 'Default (none)', value: '' },
						{ text: 'Align Left', value: 'alignleft' },
						{ text: 'Align Right', value: 'alignright' },
						{ text: 'Align Center', value: 'aligncenter' }
					],
					value: align,
					minWidth: 150,
				}],
				onsubmit: function( e ) {
					var content =  typeof e.data.content != 'undefined' ? e.data.content : '';
					//if (typeof e.data.title != 'undefined' && e.data.title.length )
						//shortcode_str += ' title="' + e.data.title + '"';
					if (typeof e.data.id != 'undefined' && e.data.id.length )
						shortcode_str += ' id="' + e.data.id + '"';
					if (typeof e.data.align != 'undefined' && e.data.align.length )
						shortcode_str += ' align="' + e.data.align + '"';
						//console.log(e.data.hide_title);
					if (typeof e.data.hide_title != 'undefined' && e.data.hide_title )
						shortcode_str += ' hide_title="1"';
					shortcode_str += ']';
					
					editor.insertContent( shortcode_str );
				}
			});
		});

        editor.addButton( 'custom_tmce_pppcp_button', {
            title: '',
            type: 'menubutton',
            icon: 'icon icon-paypal-paypal-logo',
            menu: [
                {
                    text: 'Add PayPal Button',
                    onclick: function() {
						editor.execCommand( sh_tag + '_shortcode_popup','',{
							//title 		: '', 
							id 			: '0',
							align   	: '',
							content		: ''
						});
                    }
                },
                {
                    text: 'Add View Cart Button',
                    onclick: function(e) {
						editor.insertContent( '[pppviewcart]');
                    }
                },
           ]
        });
		
		//replace from shortcode to an image placeholder
		editor.on('BeforeSetcontent', function(e){ 
			e.content = replaceShortcodes( e.content );
		});

		//replace from image placeholder to shortcode
		editor.on('GetContent', function(e){
			e.content = restoreShortcodes(e.content);
		});
		
		editor.on('touchstart',function(e) {
			e.preventDefault(); 
			touchStart	= true;
			if( !tapped ){
				tapped = setTimeout(function (){tapped = null;},300);
			}else{
				openEditorPayPalPromo(e);
				clearTimeout(tapped);
				tapped = null;
			}
		});
		
		editor.on('touchend touchcancel',function (e){
			e.preventDefault();
			touchStart = false;
		});
		
		//open popup on placeholder double click (for non Touch);
		editor.on( 'DblClick', function (e){
			openEditorPayPalPromo(e);
		});
    });
})();