(function($){
	$(document).ready(function(){
		$('.pp_promoclear').on('click',function(e){
			e.preventDefault();	
			var clickedButton 	= $(this),
				buttonId		= clickedButton.data('promocode-id');
			clearPromoCode( clickedButton, buttonId);			
		});	
		$('.pp_promoapply').on('click',function(e){
			e.preventDefault();	
			var clickedButton 	= $(this),
				buttonId		= clickedButton.data('promocode-id'),
				promoCode		= $('.'+clickedButton.data('promocode-field')).val();
			if( promoCode == ''){
				//clickedButton.parent('form').find('.ppcode-msg').html('<div style="color:#FF0000;">Error! Please enter a Promo Code.</div>');
				$('.'+clickedButton.data('promocode-field')).attr('placeholder','Error! Please enter a Promo Code.').addClass('error-outline');
				//$('.'+clickedButton.data('promocode-field'));
			}else{
				applyPromoCode( clickedButton, buttonId, promoCode);
			}
					
		});	
		
		function createCookie(name, value, days) {
			var expires;
			if (days) {
				var date = new Date();
				date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
				expires = "; expires=" + date.toGMTString();
			} else {
				expires = "";
			}
			document.cookie = encodeURIComponent(name) + "=" + encodeURIComponent(value) + expires + "; path=/";
		}
	
		function readCookie(name) {
			var nameEQ = encodeURIComponent(name) + "=";
			var ca = document.cookie.split(';');
			for (var i = 0; i < ca.length; i++) {
				var c = ca[i];
				while (c.charAt(0) === ' ') c = c.substring(1, c.length);
				if (c.indexOf(nameEQ) === 0) return decodeURIComponent(c.substring(nameEQ.length, c.length));
			}
			return null;
		}
	
		function eraseCookie(name) {
			createCookie(name, "", -1);
		}
		
		$('input[class^="pp_promocode"]').focus(function(){
			if($(this).hasClass('error-outline'))
				$(this).removeClass('error-outline').attr('placeholder','');
		});
		
		function clearPromoCode(clickedButton, buttonId){
			var activeBtn = buttonId;
			var containerObj = $('div[class*="ppp-container-"]');
			containerObj.addClass('pppspinner');
			var promo = readCookie('promocode');
			var data = { 'action': 'pppcode_ajax_helper', 'promocode': promo, 'security' : pppcodeLocalize.security, 'method' : 'clear_promocode', 'btnid' : buttonId };
			$.ajax({ 
				type: 'POST', 
				url: pppcodeLocalize.ajaxURL, 
				data: data, 
				dataType: 'json',
				success: function (dataa) { 
					if( typeof dataa.type === "string" && dataa.type == 'ok' ){
						if(typeof dataa.message === "object" && ( Object.keys(dataa.message).length ) > 0){
							activeBtn = typeof dataa.active !== 'undefined' ? dataa.active : 'not set';
							var ppforms = $('div[class*="ppp-container-"]');
							var reg_amtnc = '';
							var contMsgObj = $('div[class*="ppp-ajax-message-button-"]');
							var contMsgObj2 = $('.ppp-container-'+buttonId+' .ppcode-msg');
							
							contMsgObj.html('<!-- nothing -->');
							contMsgObj2.html('<!-- nothing -->');
							ppforms.each(function(e){
								var $thisForm = $(this);
								reg_amtnc = $thisForm.find('input[name="amount"]').data('reg-amt');
								reg_amtCC = $thisForm.find('input[name="amount"]').data('curr-symbol');
								$thisForm.find('.ppppricing').removeClass('pppdiscount');
								$thisForm.find('input[name="amount"]').val(parseFloat(reg_amtnc).toFixed(2))
								$thisForm.find('.ppppricing .pppromo-price-sale').html(reg_amtCC+reg_amtnc);
								$thisForm.find('.ppppricing .pppromo-price-strike').html('');
							});
						}
					}else if(typeof dataa.type === "string" && dataa.type == 'status'){
						if(typeof dataa.message === "string")
							message = dataa.message;
					}else if(typeof dataa.type === "string" && dataa.type == 'error'){
						if(typeof dataa.message === "string")
							message = dataa.message;
					}
				}
			})
			.done( function(dataa){
				if( typeof dataa.type === "string" && dataa.type == 'ok' ){
					$('form[name^="pp_promocode"').removeClass('pppcode-hide').addClass('pppcode-show');
					$('form[name="pp_promocodeFRMclear"').removeClass('pppcode-show').addClass('pppcode-hide');
				}
				eraseCookie('promocode');
				containerObj.removeClass('pppspinner');
			});
		}
		function applyPromoCode(clickedButton, buttonId, promocode){
			var data = { 'action': 'pppcode_ajax_helper','security' : pppcodeLocalize.security, 'promocode':promocode, 'method' : 'apply_promocode', 'btnid' : buttonId };
			var amt = '';
			var applies = '';
			var id =  '';
			var name = '';
			var pcodemsg ='';
			var reg_amt = '';
			var message = '';
			var activeBtn = buttonId;
			var containerObj = $('div[class*="ppp-container-"]');
			containerObj.addClass('pppspinner');
			$.ajax({ 
				type: 'POST', 
				url: pppcodeLocalize.ajaxURL, 
				data: data, 
				dataType: 'json',
				success: function (dataa) { 
					if( typeof dataa.type === "string" && dataa.type == 'ok' ){
						if(typeof dataa.message === "object" && ( Object.keys(dataa.message).length ) > 0){
							activeBtn = typeof dataa.active !== 'undefined' ? dataa.active : 'not set';
							$.each(dataa.message, function(index,element){
							    amt = typeof element.amt !== 'undefined' ? element.amt: '';
								applies = typeof element.applies !== 'undefined' ? element.applies : '';
								id = typeof element.id !== 'undefined' ? element.id : '';
								name = typeof element.name !== 'undefined' ? element.name : '';
								pcodemsg = typeof element.pcodemsg !== 'undefined' ? element.pcodemsg : '';
								reg_amt = typeof element.reg_amt !== 'undefined' ? element.reg_amt : '';
								var curcode = $('.ppp-container-'+id+' input[name="amount"]').data('curr-symbol');
								console.log('curcode:'+curcode);
								$('.ppp-container-'+id+' input[name="amount"]').val(parseFloat(amt).toFixed(2));
								//console.log(element);
								var contMsgObj = $('div[class*="ppp-ajax-message-button-'+id+'"]');
								if( pcodemsg != '')
									contMsgObj.html( pcodemsg );
								//if(applies == 'true'){
									$('.ppp-container-'+id+' .ppppricing').addClass('pppdiscount');
									$('.ppp-container-'+id+' .ppppricing .pppromo-price-sale').html('&nbsp;'+'Discounted Price: '+curcode+amt);
									$('.ppp-container-'+id+' .ppppricing .pppromo-price-strike').html(reg_amt);
									$('form[name^="pp_promocode"').removeClass('pppcode-show').addClass('pppcode-hide');
								//}
								//$('form[name="pp_promocodeFRMclear"').removeClass('pppcode-hide').addClass('pppcode-show');
								//console.log('.ppp-container-'+id);
							});
						}
					}else if(typeof dataa.type === "string" && dataa.type == 'status'){
						if(typeof dataa.message === "string")
							message = dataa.message;
					}else if(typeof dataa.type === "string" && dataa.type == 'error'){
						if(typeof dataa.message === "string")
							message = dataa.message;
					}
				}
			})
			
			.done( function(dataa){
				if( typeof dataa.type === "string" && dataa.type == 'ok' ){
					$('form[name^="pp_promocode"').removeClass('pppcode-show').addClass('pppcode-hide');
					$('form[name="pp_promocodeFRMclear"').removeClass('pppcode-hide').addClass('pppcode-show');
				}
				createCookie('promocode',promocode,30);
				containerObj.removeClass('pppspinner');
			});

		}
	});
	function sendAjaxRequest(data) {
		data.action = 'pppcode_ajax_helper';
		$.ajax({ 
			type: 'POST', 
			url: pppcodeLocalize.ajaxURL, 
			data: data, 
			dataType: 'json',
			success: function (dataa) { 
				return dataa;
			}
		});
		/*
		$.post(pppcodeLocalize.ajaxURL, data, function(feedback){
			var dataR = feedback;
			console.log(dataR);
			if(dataR.type == 'ok'){
				var updated = dataR.message;
				console.log("ok:\n"+feedback.message);
			}else if(feedback.type == 'status'){
				console.log("There was an error:\n"+feedback.message);
			}else if(feedback.type == 'error'){
				alert("There was an error:\n"+feedback.message);
			}
		}, 'json');
		*/
	}

})(jQuery);
