<?php
	global $wp, $wpdb,$paypal_promocode_instance;
	$ppcart_info				= $wpdb->prefix . 'paypal_cart_info';
	$ppsubscribe_info			= $wpdb->prefix . 'paypal_subscription_info';
	$pppayment_info				= $wpdb->prefix . 'paypal_payment_info';
	$pppromo					= $wpdb->prefix . 'pppromo';
	$pppromoproducts			= $wpdb->prefix . 'pppromoproducts';
	$notify_email				= get_bloginfo('admin_email'); 
	$testing					= getMultiOption('ppp_options','sandbox') == 'true' ? 1 : 0;
	$formurl 					= $testing == 1 ? 'sandbox.' : '';
	$sendNotice 				= getMultiOption('ppp_options','nonotice')== 'true' ? 0 : 1;

	/* be careful not to write to page or redirect will not work; */
	/* TODO: add options to admin panel for notification when PAYPAL INS is processed */

	// read the post from PayPal system and add 'cmd'
		$req = 'cmd=_notify-validate';
		if(isset($_REQUEST['payment_status'])){
			foreach ($_REQUEST as $key => $value) {
				$value = urlencode(stripslashes($value));
				$req .= "&$key=$value";
			}
		}

// post back to PayPal system to validate
	if(function_exists('fsockopen')) { //fsockopen function is enabled
		$header 		= "POST /cgi-bin/webscr HTTP/1.0\r\n"; 
		$header 		.= "Content-Type: application/x-www-form-urlencoded\r\n";
		$header 		.= "Content-Length: " . strlen($req) . "\r\n\r\n";
		$fp 			= fsockopen ('ssl://www.'.$formurl.'paypal.com', 443, $errno, $errstr, 30);
		$using			= 'fp';
	} else {//fsockopen is not enabled, use CURL
		$url = "https://www.paypal.com/cgi-bin/webscr";
		$curl_result=$curl_err='';
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL,$url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $req);
		curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: application/x-www-form-urlencoded", "Content-Length: " . strlen($req)));
		curl_setopt($ch, CURLOPT_HEADER , 0);   
		curl_setopt($ch, CURLOPT_VERBOSE, 1);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_TIMEOUT, 30);
		$the_result = @curl_exec($ch);
		$the_err = curl_error($ch);
		curl_close($ch);
		$using			= 'curl';
	}
	$req2 = str_replace("&", "\n", $req);
	
// assign posted variables to local variables
	$item_name			= addslashes(stripslashes(stripslashes($_REQUEST['item_name'])));
	$business			= addslashes(stripslashes(stripslashes($_REQUEST['business'])));
	$item_number		= addslashes(stripslashes(stripslashes($_REQUEST['item_number'])));
	$payment_status		= addslashes(stripslashes(stripslashes($_REQUEST['payment_status'])));
	$mc_gross			= addslashes(stripslashes(stripslashes($_REQUEST['mc_gross'])));
	$payment_currency	= addslashes(stripslashes(stripslashes($_REQUEST['mc_currency'])));
	$txn_id				= addslashes(stripslashes(stripslashes($_REQUEST['txn_id'])));
	$receiver_email		= addslashes(stripslashes(stripslashes($_REQUEST['receiver_email'])));
	$receiver_id		= addslashes(stripslashes(stripslashes($_REQUEST['receiver_id'])));
	$quantity			= addslashes(stripslashes(stripslashes($_REQUEST['quantity'])));
	$num_cart_items		= addslashes(stripslashes(stripslashes($_REQUEST['num_cart_items'])));
	$payment_date		= addslashes(stripslashes(stripslashes($_REQUEST['payment_date'])));
	$first_name			= addslashes(stripslashes(stripslashes($_REQUEST['first_name'])));
	$last_name			= addslashes(stripslashes(stripslashes($_REQUEST['last_name'])));
	$payment_type		= addslashes(stripslashes(stripslashes($_REQUEST['payment_type'])));
	$payment_status		= addslashes(stripslashes(stripslashes($_REQUEST['payment_status'])));
	$payment_gross		= addslashes(stripslashes(stripslashes($_REQUEST['payment_gross'])));
	$payment_fee		= addslashes(stripslashes(stripslashes($_REQUEST['payment_fee'])));
	$settle_amount		= addslashes(stripslashes(stripslashes($_REQUEST['settle_amount'])));
	$memo				= addslashes(stripslashes(stripslashes($_REQUEST['memo'])));
	$payer_email		= addslashes(stripslashes(stripslashes($_REQUEST['payer_email'])));
	$txn_type			= addslashes(stripslashes(stripslashes($_REQUEST['txn_type'])));
	$payer_status		= addslashes(stripslashes(stripslashes($_REQUEST['payer_status'])));
	$address_street		= addslashes(stripslashes(stripslashes($_REQUEST['address_street'])));
	$address_city		= addslashes(stripslashes(stripslashes($_REQUEST['address_city'])));
	$address_state		= addslashes(stripslashes(stripslashes($_REQUEST['address_state'])));
	$address_zip		= addslashes(stripslashes(stripslashes($_REQUEST['address_zip'])));
	$address_country	= addslashes(stripslashes(stripslashes($_REQUEST['address_country'])));
	$address_status		= addslashes(stripslashes(stripslashes($_REQUEST['address_status'])));
	$item_number		= addslashes(stripslashes(stripslashes($_REQUEST['item_number'])));
	$tax				= addslashes(stripslashes(stripslashes($_REQUEST['tax'])));
	$option_name1		= addslashes(stripslashes(stripslashes($_REQUEST['option_name1'])));
	$option_selection1	= addslashes(stripslashes(stripslashes($_REQUEST['option_selection1'])));
	$option_name2		= addslashes(stripslashes(stripslashes($_REQUEST['option_name2'])));
	$option_selection2	= addslashes(stripslashes(stripslashes($_REQUEST['option_selection2'])));
	$for_auction		= addslashes(stripslashes(stripslashes($_REQUEST['for_auction'])));
	$invoice			= addslashes(stripslashes(stripslashes($_REQUEST['invoice'])));
	$custom				= addslashes(stripslashes(stripslashes($_REQUEST['custom'])));
	$notify_version		= addslashes(stripslashes(stripslashes($_REQUEST['notify_version'])));
	$verify_sign		= addslashes(stripslashes(stripslashes($_REQUEST['verify_sign'])));
	$payer_bus_name		= addslashes(stripslashes(stripslashes($_REQUEST['payer_business_name'])));
	$payer_id 			= addslashes(stripslashes(stripslashes($_REQUEST['payer_id'])));
	$mc_currency		= addslashes(stripslashes(stripslashes($_REQUEST['mc_currency'])));
	$mc_fee				= addslashes(stripslashes(stripslashes($_REQUEST['mc_fee'])));
	$exchange_rate		= addslashes(stripslashes(stripslashes($_REQUEST['exchange_rate'])));
	$settle_currency 	= addslashes(stripslashes(stripslashes($_REQUEST['settle_currency'])));
	$parent_txn_id 		= addslashes(stripslashes(stripslashes($_REQUEST['parent_txn_id'])));
	$pending_reason		= addslashes(stripslashes(stripslashes($_REQUEST['pending_reason'])));
	$reason_code		= addslashes(stripslashes(stripslashes($_REQUEST['reason_code'])));
//custom variable only for this plugin
	$placetogo			= addslashes(stripslashes(stripslashes($_REQUEST['newreturn_url'])));
	$procodebutton_used = addslashes(stripslashes(stripslashes($_REQUEST['paypaypromo_buttonid'])));
	$procode_used		= addslashes(stripslashes(stripslashes($_REQUEST['promocode_usedid'])));
// subscription specific vars
	$subscr_id			= addslashes(stripslashes(stripslashes($_REQUEST['subscr_id'])));
	$subscr_date		= addslashes(stripslashes(stripslashes($_REQUEST['subscr_date'])));
	$subscr_effective 	= addslashes(stripslashes(stripslashes($_REQUEST['subscr_effective'])));
	$period1			= addslashes(stripslashes(stripslashes($_REQUEST['period1'])));
	$period2			= addslashes(stripslashes(stripslashes($_REQUEST['period2'])));
	$period3			= addslashes(stripslashes(stripslashes($_REQUEST['period3'])));
	$amount1			= addslashes(stripslashes(stripslashes($_REQUEST['amount1'])));
	$amount2			= addslashes(stripslashes(stripslashes($_REQUEST['amount2'])));
	$amount3			= addslashes(stripslashes(stripslashes($_REQUEST['amount3'])));
	$mc_amount1			= addslashes(stripslashes(stripslashes($_REQUEST['mc_amount1'])));
	$mc_amount2			= addslashes(stripslashes(stripslashes($_REQUEST['mc_amount2'])));
	$mc_amount3			= addslashes(stripslashes(stripslashes($_REQUEST['mcamount3'])));
	$recurring			= addslashes(stripslashes(stripslashes($_REQUEST['recurring'])));
	$reattempt			= addslashes(stripslashes(stripslashes($_REQUEST['reattempt'])));
	$retry_at			= addslashes(stripslashes(stripslashes($_REQUEST['retry_at'])));
	$recur_times		= addslashes(stripslashes(stripslashes($_REQUEST['recur_times'])));
	$username			= addslashes(stripslashes(stripslashes($_REQUEST['username'])));
	$password			= addslashes(stripslashes(stripslashes($_REQUEST['password'])));
//auction specific vars
	$for_auction		= addslashes(stripslashes(stripslashes($_REQUEST['for_auction'])));
	$auction_close_date = addslashes(stripslashes(stripslashes($_REQUEST['auction_closing_date'])));
	$auction_multi_item = addslashes(stripslashes(stripslashes($_REQUEST['auction_multi_item'])));
	$auction_buyer_id 	= addslashes(stripslashes(stripslashes($_REQUEST['auction_buyer_id'])));

	$sihay = $wpdb->get_var("SELECT txnid FROM $pppayment_info WHERE txnid='".$txn_id."' LIMIT 1");
	$is_verified = 0;
	$is_valid = 1;
	
	if(count($sihay) >= 1){ 
		$tempvals 			= urldecode($custom);
		$customItmes 		= explode('|', $tempvals);	//check temp variables and redirect to proper RETURN URL page (specified in button)
		unset($_SESSION['procode']);//clear PromoCode Session
		wp_redirect($customItmes[1],302);
	}else{
		if ((!$fp && $using =='fp') || (!$the_result && $using =='curl')) {
			// HTTP ERROR
		} else {
			if($using == 'fp'){ //fsockopen
				fputs ($fp, $header . $req);
				while (!feof($fp)) {
					$res = fgets ($fp, 1024);
					if (strcmp ($res, "VERIFIED") == 0) {
				    	$req2 .= "\n\nPaypal Verified OK";
						$is_verified = 1;
					}else{
						$req2 .= "\n\nData NOT verified from Paypal!";
						if (strcmp ($res, "INVALID") == 0) {
							$req2 .= "\n\nINVALID IPN!";
							$is_valid = 0;
						}
					}
				}
				fclose ($fp);
			}else{ //curl
				if (strpos($the_result, "VERIFIED") !== false) {
				    $req2 .= "\n\nPaypal Verified OK";
					$is_verified = 1;
				}else{
					$req2 .= "\n\nData NOT verified from Paypal!";
					if(strpos($the_result, "INVALID") !== false) {
						$req2 .= "\n\nINVALID IPN!";
						$is_valid = 0;
					}
				}
			}
			//echo $req2;
			echo '['.$is_verified.']';
			$is_verified = 1;
			if($is_verified == 1){
				$fecha = date("m")."/".date("d")."/".date("Y");
				$fecha = date("Y").date("m").date("d");
				//check if transaction ID has been processed before
				$ispros = $wpdb->get_var("SELECT txnid FROM $pppayment_info WHERE txnid='".$txn_id."' LIMIT 1");
				$nm = count($ispros);
				if ($nm >= 1){ //means it was already processed.						
					// send an email about Duplicate (probably page refresh or error)
				 	if($sendNotice==1){
						wp_mail($notify_email, "VERIFIED DUPLICATED TRANSACTION", "$res\n $req \n $strQuery\n $struery\n  $strQuery2");
					}
				}else{
					//execute query
					$buyerinfo[] = stripslashes('Transaction ID Number: '.$txn_id."\n");
					$buyerinfo[] = stripslashes('Payment Status: '.$payment_status);
					$buyerinfo[] = '-----';
					$buyerinfo[] = '';
					$buyerinfo[] = stripslashes('Name: '.$first_name . ' '.$last_name);
					$buyerinfo[] = stripslashes('Email: '.$payer_email);
					$buyerinfo[] = stripslashes($address_street);
					$buyerinfo[] = stripslashes($address_city.', '.$address_state.' '.$address_zip);
					$buyerinfo[] = stripslashes($address_country);
					$buyerinfo[] = stripslashes('Address Status: '.$address_status);
					$buyerinfo[] = '';
					$buyerinfo[] = stripslashes('Buyer Status: '.$payer_status);
					$buyerinfo[] = stripslashes('Payment Type: '.$payment_type);
					$buyerinfo[] = 'Protection Eligibility: '.stripslashes($_REQUEST['protection_eligibility']);
				//CART TYPE TRANSACTION
				    if ($txn_type == "cart"){
				     	 $transxdetail= '-------------------------'."\n\n".'Cart Item(s):'."\n";
					     $strQuery = "INSERT INTO $pppayment_info (paymentstatus,buyer_email,firstname,lastname,street,city,state,zipcode,country,mc_gross,mc_fee,memo,paymenttype,paymentdate,txnid,pendingreason,reasoncode,txntype,tax,mc_currency,datecreation,custom) values ('".$payment_status."','".$payer_email."','".$first_name."','".$last_name."','".$address_street."','".$address_city."','".$address_state."','".$address_zip."','".$address_country."','".$mc_gross."','".$mc_fee."','".$memo."','".$payment_type."','".$payment_date."','".$txn_id."','".$pending_reason."','".$reason_code."','".$txn_type."','".$tax."','".$payment_currency."','".$fecha."','".$custom."')";
					     $result = $wpdb->query($strQuery);
						 if($num_cart_items == ''){$num_cart_items = 25;}//guess if none - 25 seems excessive in number, but oh well
					     for ($i = 1; $i <= $num_cart_items; $i++) {
							 if(isset($_REQUEST["item_name"]) && $i==1){
								 $itemname 		= addslashes(stripslashes(stripslashes($_REQUEST["item_name"])));
								 $itemnumber 	= addslashes(stripslashes(stripslashes($_REQUEST["item_number"])));
								 $on0 			= addslashes(stripslashes(stripslashes($_REQUEST["option_name1"])));
								 $os0 			= addslashes(stripslashes(stripslashes($_REQUEST["option_selection1"])));
								 $on1 			= addslashes(stripslashes(stripslashes($_REQUEST["option_name2"])));
								 $os1 			= addslashes(stripslashes(stripslashes($_REQUEST["option_selection2"])));
								 $quantity 		= addslashes(stripslashes(stripslashes($_REQUEST["quantity"])));
								 $mctx 			= addslashes(stripslashes(stripslashes($_REQUEST["mc_tax"])));
								 $handle		= addslashes(stripslashes(stripslashes($_REQUEST["mc_handling"])));
								 $mcship 		= addslashes(stripslashes(stripslashes($_REQUEST["mc_shipping"])));
								 $tax 			= addslashes(stripslashes(stripslashes($_REQUEST["tax"])));
								 $itemcost 		= addslashes(stripslashes(stripslashes($_REQUEST["mc_gross_"])));
								 $struery = "INSERT INTO $ppcart_info (txnid,itemnumber,itemname,os0,on0,os1,on1,quantity,invoice,custom) values ('".$txn_id."','".$itemnumber."','".$itemname."','".$on0."','".$os0."','".$on1."','".$os1."','".$quantity."','".$invoice."','".$custom."')";
								 $result = $wpdb->query($struery);
								 if($itemnumber==''){$itemtemp = '';}else{$itemtemp = '('.$itemnumber.')';}
								 $transxdetail .= $quantity.' - '.$itemname . $itemtemp . ' - $'.$itemcost . "\n";
							 }
							 if(isset($_REQUEST["item_name".$i])){
								 $itemname 		= addslashes(stripslashes(stripslashes($_REQUEST["item_name".$i])));
								 $itemnumber 	= addslashes(stripslashes(stripslashes($_REQUEST["item_number".$i])));
								 $on0 			= addslashes(stripslashes(stripslashes($_REQUEST["option_name1".$i])));
								 $os0 			= addslashes(stripslashes(stripslashes($_REQUEST["option_selection1".$i])));
								 $on1 			= addslashes(stripslashes(stripslashes($_REQUEST["option_name2".$i])));
								 $os1 			= addslashes(stripslashes(stripslashes($_REQUEST["option_selection2".$i])));
								 $quantity 		= addslashes(stripslashes(stripslashes($_REQUEST["quantity".$i])));
								 $mctx 			= addslashes(stripslashes(stripslashes($_REQUEST["mc_tax".$i])));
								 $handle		= addslashes(stripslashes(stripslashes($_REQUEST["mc_handling".$i])));
								 $mcship 		= addslashes(stripslashes(stripslashes($_REQUEST["mc_shipping".$i])));
								 $tax 			= addslashes(stripslashes(stripslashes($_REQUEST["tax".$i])));
								 $itemcost 		= addslashes(stripslashes(stripslashes($_REQUEST["mc_gross".$i])));
								 $struery = "INSERT INTO $ppcart_info (txnid,itemnumber,itemname,os0,on0,os1,on1,quantity,invoice,custom) values ('".$txn_id."','".$itemnumber."','".$itemname."','".$on0."','".$os0."','".$on1."','".$os1."','".$quantity."','".$invoice."','".$custom."')";
								 $result = $wpdb->query($struery);
								 if($itemnumber==''){$itemtemp = '';}else{$itemtemp = '('.$itemnumber.')';}
								 $transxdetail .= $quantity.' - '.$itemname . $itemtemp . ' - $'.$itemcost . "\n";
							 }
					     }
					     $buyerinfo[] =stripslashes($transxdetail);
					     $pppsubject = 'A PayPal Cart Checkout has been made.';
				
				//Donation TYPE TRANSACTION
				    }elseif ($txn_type == "donation"){
				     	 $transxdetail= '-------------------------'."\n\n".'Donation Details:'."\n";
					     $strQuery = "insert into $pppayment_info (paymentstatus,buyer_email,firstname,lastname,street,city,state,zipcode,country,mc_gross,mc_fee,itemnumber,itemname,os0,on0,os1,on1,quantity,memo,paymenttype,paymentdate,txnid,pendingreason,reasoncode,tax,datecreation) values ('".$payment_status."','".$payer_email."','".$first_name."','".$last_name."','".$address_street."','".$address_city."','".$address_state."','".$address_zip."','".$address_country."','".$mc_gross."','".$mc_fee."','".$item_number."','".$item_name."','".$option_name1."','".$option_selection1."','".$option_name2."','".$option_selection2."','".$quantity."','".$memo."','".$payment_type."','".$payment_date."','".$txn_id."','".$pending_reason."','".$reason_code."','".$tax."','".$fecha."')";
					     $result = $wpdb->query($strQuery);
				         $itemname 		= addslashes(stripslashes(stripslashes($_REQUEST["item_name"])));
				         $itemnumber 	= addslashes(stripslashes(stripslashes($_REQUEST["item_number"])));
				         $quantity 		= 1;
						 $itemcost 		= addslashes(stripslashes(stripslashes($_REQUEST["mc_gross"])));
				         if($itemnumber==''){$itemtemp = '';}else{$itemtemp = '('.$itemnumber.')';}
				         $transxdetail .= $quantity.' - '.$itemname . $itemtemp . ' - $'.$itemcost . "\n";
				     	 $buyerinfo[] =stripslashes($transxdetail);
				     	 $pppsubject = 'A PayPal Donation has been made.';
				
				//Any Other TYPE TRANSACTION
				    }else{
				     	 $transxdetail= '-------------------------'."\n\n".'Purchased Item(s):'."\n";
					     $strQuery = "insert into $pppayment_info (paymentstatus,buyer_email,firstname,lastname,street,city,state,zipcode,country,mc_gross,mc_fee,itemnumber,itemname,os0,on0,os1,on1,quantity,memo,paymenttype,paymentdate,txnid,pendingreason,reasoncode,tax,datecreation) values ('".$payment_status."','".$payer_email."','".$first_name."','".$last_name."','".$address_street."','".$address_city."','".$address_state."','".$address_zip."','".$address_country."','".$mc_gross."','".$mc_fee."','".$item_number."','".$item_name."','".$option_name1."','".$option_selection1."','".$option_name2."','".$option_selection2."','".$quantity."','".$memo."','".$payment_type."','".$payment_date."','".$txn_id."','".$pending_reason."','".$reason_code."','".$tax."','".$fecha."')";
					     $result = $wpdb->query($strQuery);
				         $itemname 		= addslashes(stripslashes(stripslashes($_REQUEST["item_name"])));
				         $itemnumber 	= addslashes(stripslashes(stripslashes($_REQUEST["item_number"])));
				         $on0 			= addslashes(stripslashes(stripslashes($_REQUEST["option_name1"])));
				         $os0 			= addslashes(stripslashes(stripslashes($_REQUEST["option_selection1"])));
				         $on1 			= addslashes(stripslashes(stripslashes($_REQUEST["option_name2"])));
				         $os1 			= addslashes(stripslashes(stripslashes($_REQUEST["option_selection2"])));
				         $quantity 		= addslashes(stripslashes(stripslashes($_REQUEST["quantity"])));
				         $mctx 			= addslashes(stripslashes(stripslashes($_REQUEST["mc_tax"])));
				         $handle		= addslashes(stripslashes(stripslashes($_REQUEST["mc_handling"])));
						 $mcship 		= addslashes(stripslashes(stripslashes($_REQUEST["mc_shipping"])));
						 $tax 			= addslashes(stripslashes(stripslashes($_REQUEST["tax"])));
						 $itemcost 		= addslashes(stripslashes(stripslashes($_REQUEST["mc_gross"])));
				         if($itemnumber==''){$itemtemp = '';}else{$itemtemp = '('.$itemnumber.')';}
				         $transxdetail .= $quantity.' - '.$itemname . $itemtemp . ' - $'.$itemcost . "\n";
				     	 $buyerinfo[] =stripslashes($transxdetail);
				     	 $pppsubject = 'A PayPal Transaction was completed successfully.';
				    }
				    //subscription handling 
				    if ( $txn_type == "subscr_signup"  ||  $txn_type == "subscr_payment"  ) {
						// insert subscriber payment info into paypal_payment_info table
						$wpdb->query("insert into $pppayment_info (paymentstatus,buyer_email,firstname,lastname,street,city,state,zipcode,country,mc_gross,mc_fee,memo,paymenttype,paymentdate,txnid,pendingreason,reasoncode,tax,datecreation) values ('".$payment_status."','".$payer_email."','".$first_name."','".$last_name."','".$address_street."','".$address_city."','".$address_state."','".$address_zip."','".$address_country."','".$mc_gross."','".$mc_fee."','".$memo."','".$payment_type."','".$payment_date."','".$txn_id."','".$pending_reason."','".$reason_code."','".$tax."','".$fecha."')");
						// insert subscriber info into paypal_subscription_info table
						$wpdb->query("insert into ppsubscribe_info (subscr_id , sub_event, subscr_date ,subscr_effective,period1,period2, period3, amount1 ,amount2 ,amount3,  mc_amount1,  mc_amount2,  mc_amount3, recurring, reattempt,retry_at, recur_times, username ,password, payment_txn_id, subscriber_emailaddress, datecreation) values ('".$subscr_id."', '".$txn_type."','".$subscr_date."','".$subscr_effective."','".$period1."','".$period2."','".$period3."','".$amount1."','".$amount2."','".$amount3."','".$mc_amount1."','".$mc_amount2."','".$mc_amount3."','".$recurring."','".$reattempt."','".$retry_at."','".$recur_times."','".$username."','".$password."', '".$txn_id."','".$payer_email."','".$fecha."')");
					 	if($sendNotice==1){/*send an email*/wp_mail($notify_email, "Successful PayPal Subscription Payment", "$res\n $req2\n $strQuery\n $struery\n  $strQuery2");}
				    }else{
				    	$message = implode("\n",$buyerinfo);
					 	if($sendNotice==1){wp_mail($notify_email, $pppsubject, $message);}// send an email in any case
				    }
				}
			}
		}
		if($sendNotice == 1 && $is_valid == 0){wp_mail($notify_email, "Instant Payment Notification (IPN) Interaction Not Verified!", "$res\n $req2");} // if the IPN POST was 'INVALID', send email for manual investigation
		$tempvals 			= urldecode($custom);
		$customItmes 		= explode('|', $tempvals);	//check temp variables and redirect to proper RETURN URL page (specified in button)
		$paypal_promocode_instance->update_pppcounts('ppp_btntrk_'.$customItmes[0]);
		unset($_SESSION['procode']); //clear PromoCode Session
		wp_redirect($customItmes[1],302); //redirect to return url
	}
