<?php

class PayPalPromo_addCustomMCE_FCM {
	function __construct(){
		add_action( 'admin_head', array( $this, 'custom_add_tmce_button' ) );
		add_action( 'admin_enqueue_scripts', array( $this, 'custom_tmce_css' ) );
	}

	function custom_add_tmce_button() {
		global $typenow;
		$stop = true;
		if ( $typenow == 'page' &&  current_user_can( 'edit_pages' )){
			$stop = false;
		} elseif (  $typenow == 'post' && current_user_can( 'edit_posts' ) ){
			$stop = false;
		}
		if ( get_user_option('rich_editing') == 'true' && $stop == false) {
			add_filter( 'mce_external_plugins', array( $this, 'custom_add_tinymce_plugin' ) );
			add_filter( 'mce_buttons', array( $this, 'custom_register_tmce_button' ) );
		}
		return;
	}
	
	function custom_add_tinymce_plugin($plugin_array) {
		$plugin_array['custom_tmce_pppcp_button'] = plugins_url( '/js/complex-popup-button.js', dirname( __FILE__ ) );
		return $plugin_array;
	}
	
	function custom_register_tmce_button($buttons) {
		array_push($buttons, 'custom_tmce_pppcp_button');
		return $buttons;
	}
	
	function custom_tmce_css() {
		wp_enqueue_style('custom-tmce', plugins_url('/css/style.css', dirname( __FILE__ )));
	}
}
new PayPalPromo_addCustomMCE_FCM();